//  dn.c  2/27/90  Stephen Balbach
//  Allows entry of notes for files in a directory
//  Public Domain.  Compiled with CSCAPE 3.0
//		    windowing package under MSC 5.1. Should be
//		    very easy to convert to another
//		    windowing package. I flagged each
//		    line that is CSCAPE specific.
//		    NOTE: unlike some other dirnotes programs
//		    this keeps track of deleted and new file
//		    additions!


#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

#include <cscape.h>

#define VERSION 1
#define MAXFILES 500
#define MAXDESCRIPT 64

struct file_list {
		 char name[13];
		 char descrip[MAXDESCRIPT];
		 };


static struct file_list master_list[MAXFILES];	// array of structures of type file_list

char file_list[MAXFILES][13];			// char array of files in directory

FILE *file_data;				// data file pointer

menu_type  menu_master; 			// windowing library stuff (CSCAPE)
sed_type   sed_master;				// (CSCAPE)

void main()
{
struct find_t file_info;
int i;

    disp_Init(pc_ModeCurrent,NULL);	       // Set up the screen (CSCAPE)
    sedwin_ClassInit();

    menu_master = menu_Open();		       // Open the window library data structure (CSCAPE)

    if(number_files_cwd("*.*") > MAXFILES)     // make sure not too many files
    {
      eror("DirNotes allows up to 500 files entries.");
      goodbye();
    }


    if(file_exists("dn.dat"))		       // Open the data file
    {
      if(!(file_data = fopen("dn.dat","r+")))
      {
	eror("Eror re-opening data file");
	goodbye();
      }
      read_files_in_dir_into_array();	       // read files in dir into file_list[]
      read_files_in_file_into_array();	      // read files in data file into master_list[]
    }
    else
      {
	if(!(file_data = fopen("dn.dat","w+")))
	{
	  eror("Eror creating data file");
	  goodbye();
	}
	read_files_in_dir_into_array();
      }


    for(i = 0; i < MAXFILES; i++)	      // For each file, define a field
    {
      if(strcmpi(master_list[i].name,"") != 0)
      {
	menu_Printf(menu_master,"%-12s - ",master_list[i].name);  // (CSCAPE)
	menu_Printf(menu_master,"@f[################################################################]\n",master_list[i].descrip,&string_funcs);  // (CSCAPE)
      }
    }

    sed_master = sed_Open(menu_master);  // (CSCAPE)
    sed_SetHeight(sed_master,23);	 // (CSCAPE)
    sed_SetBorder(sed_master,NULL);	 // (CSCAPE)
    sed_Repaint(sed_master);		 // (CSCAPE)
    sed_Go(sed_master); 		// This runs the sed, shows the fields defines above (CSCAPE)
    write_files_from_array_to_file();	// Write info back out to file
    goodbye();				// Exit

}

read_files_in_file_into_array()  // Routine to read the data in the file into the master_list array
{
int i=0,k,l,ok,next;


    for(i = 0; i < MAXFILES; i++)	 // initialize stuff to nulls
    {
      strcpy(master_list[i].name,"");
      strcpy(master_list[i].descrip,">");
    }

    fseek(file_data,0L,SEEK_SET);	// go to beggining of file

/* Add files in from file */

    for(i = 0; !feof(file_data); i++)	 // while not eof
    {
      if(!feof(file_data))
      {

	fscanf(file_data,"%12s - ",master_list[i].name);      // read file name
	fscanf(file_data,"%[^\n]",master_list[i].descrip);    // read file descrip

	ok = 0;

	for(k = 0; k < MAXFILES; k++)			    // make sure the file has not been deleted since dn.exe last used
	{
	  if(strcmpi(file_list[k],"") == 0) break;
	  if(strcmpi(file_list[k],master_list[i].name) == 0)
	    ok = 1;
	}

	if(ok == 0)		// remove from list files no longer in dir
	{
	  strcpy(master_list[i].name,"");
	  strcpy(master_list[i].descrip,">");
	}
      }
    }

/* Add new files in directory */

    for(k = 0; k < MAXFILES; k++)
    {
      if(strcmpi(file_list[k],"") == 0)
	break;

      ok = 0;

      for(l = 0; l < MAXFILES; l++)
      {
	if(strcmpi(file_list[k],master_list[l].name) == 0)
	{
	  ok = 1;
	  break;
	}
      }

      if(ok == 0)
      {
	if(i >= MAXFILES)
	  break;
	strcpy(master_list[i].name,file_list[k]);
	i++;
      }

    }

}


read_files_in_dir_into_array()	   // Read files in dir into master_list and file_list
{
struct find_t file_info;
int result = 0,
    i = 0;


    for(i = 0; i < MAXFILES; i++)
    {
      strcpy(master_list[i].name,"");
      strcpy(master_list[i].descrip,">");
      strcpy(file_list[i],"");

    }

    result = _dos_findfirst("*.*",_A_NORMAL,&file_info);

    i = -1;

    while(!result)
    {
      i++;
      strcpy(master_list[i].name,file_info.name);
      strcpy(file_list[i],file_info.name);
      result = _dos_findnext(&file_info);
    }

    return;

}


write_files_from_array_to_file()   // Write info from arrays back out to data file
{
int i=0;

    fseek(file_data,0L,SEEK_SET);

    while(i < MAXFILES)
    {
      if(strcmpi(master_list[i].name,"") != 0)
	fprintf(file_data,"%-12s - %s\n",master_list[i].name,master_list[i].descrip);
      i++;
    }
}

int file_exists(char type[])	// Generic routine to check for file existince (wildcards OK)
{
struct find_t file_info;
int result = 0;

    result = _dos_findfirst(type,_A_NORMAL,&file_info);
    if(!result)
      return TRUE;
    else return FALSE;

}

int number_files_cwd(char type[])    // Returns number of files in CWD
{
struct find_t file_info;
int result = 0,
    count = 0;

    result = _dos_findfirst(type,_A_NORMAL,&file_info);

    while(!result)
    {
      count++;
      result = _dos_findnext(&file_info);
    }

    return count;

}

goodbye()
{

    disp_Close();
    printf("\033[2J");				  // Clear screen
    printf("\nDur Notes 1990 (Steve Balbach)\n\n");
    exit(0);

}

eror(char messg[])
{
    disp_Close();
    printf("\033[2J");
    printf("%s\n\n",messg);
    exit(0);

}
